"use strict";

var TDPJSObjectMerge=function TDPJSObjectMergeFn()
{
	// Public vars and methods

	// This is taken from underscore.js (with some adaptations to make it merge rather than replace sub-objects)
	// and to replace the isObject with a simpler and more appropriate (for this use) test: https://github.com/jashkenas/underscore/blob/master/underscore.js
	this.merge=function mergeFn(obj)
	{
		var i, source, prop, length;

		if(typeof(obj)!=="object")
		{
			return obj;
		}

	    for(i=1, length=arguments.length; i<length; i++)
	    {
			source=arguments[i];

			for(prop in source)
			{				
				// Recurse into sub-objects
				if(typeof(source[prop])==="object")
				{
					// This could do with some refinement - might be able to simplify the conddition
					if(!prop in obj || typeof(obj[prop])!=="object")
					{
						obj[prop]=source[prop];
					}

					obj[prop]=this.merge(obj[prop], source[prop]);
				}
				else
				{
					obj[prop]=source[prop];
				}
			}
	    }

	    return obj;

	}.bind(this);

	return this;
};

module.exports=TDPJSObjectMerge;